﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="KoGrid.aspx.cs" Inherits="KnockOutGrid.KoGrid" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="Framework/JQuery/jquery-ui-1.12.1/jquery-ui.css" rel="stylesheet" />
    <script src="Framework/JQuery/jquery-ui-1.12.1/external/jquery/jquery.js"></script>
    <script src="Framework/JQuery/jquery-ui-1.12.1/jquery-ui.js"></script>
    <link href="Framework/BootStrap/bootstrap-4.0.0-alpha.6-dist/css/bootstrap.min.css" rel="stylesheet" />
    <link href="Framework/BootStrap/bootstrap-4.0.0-alpha.6-dist/css/bootstrap.css" rel="stylesheet" />
    <script src="Framework/BootStrap/bootstrap-4.0.0-alpha.6-dist/js/bootstrap.min.js"></script>
    <script src="Framework/JS/bubu.js"></script>
    <script src="Framework/knockout-3.4.2.js"></script>
    <script src="Framework/knockout.simpleGrid.3.0.js"></script>
    <link href="Framework/font/font-awesome-4.7.0/css/font-awesome.min.css" rel="stylesheet" />

    <style>
        /* Mobile Safari reflows pages slowly, so fix the height to avoid the need for reflows */



        .ddlWidth260 {
            width: 260px;
            height: 30px;
        }

        .ddl {
            color: #fff;
            background-color: #a7a3a3;
            border-color: #696b6f;
        }

        tr {
            text-align: left;
        }

        .trCenter {
            text-align: center;
        }

        .cursor {
            cursor: pointer;
        }

        .bold {
            font-weight: bold;
        }

        table#tblHeading {
            font-size: 16px;
            font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
            border-collapse: collapse;
            border-spacing: 0;
            width: 100%;
        }

        #tblHeading thead {
            padding-top: 11px;
            padding-bottom: 11px;
            background-color: #4CAF50;
            color: white;
        }

        #tblHeading tr:nth-child(even) {
            background-color: #f2f2f2;
        }

        .width100 {
            width: 100%;
        }

        .icon-search {
            color: white;
            background-color: black;
        }
    </style>
</head>

<script>
    var PagedGridModel = function () {
        var self = this;
        self.items = ko.observableArray();
        self.itemsTemp = ko.observableArray();
        self.itemsPaging = ko.observableArray();
        self.pageSize = ko.observable();
        self.origionalItem = ko.observableArray();

        self.loadData = function (from, count) {
            $.ajax({
                type: "POST",
                url: 'KoGrid.aspx/GetEmployeeList',
                contentType: "application/json;",// charset=utf-8",
                data: "{'from':" + from + ",'count':" + count + "}",
                dataType: "json",
                success: function (results) {
                    self.items(results.d.employeeuserList);
                    self.itemsTemp(results.d.employeeuserList);
                    self.paging(results.d.TotalCount);
                },
                error: function (err) { alert(err.status + " - " + err.statusText); }

            });
        }
        self.paging = function (totalRecord) {
            self.itemsPaging([]);
            var filtercount = self.pageSize();
            var totalIteration = Math.ceil(totalRecord / filtercount);
            if (totalIteration > 1) {
                for (var i = 1; i <= totalIteration; i++) {
                    self.itemsPaging.push(i);
                }
            }
        }
        self.pageSizeChange = function () {
            self.loadData(0, self.pageSize());
        }
        self.moveToPage = function (PageNumber) {
            var count = self.pageSize();
            var from = (PageNumber - 1) * count;
            self.loadData(from, count);
        }
        self.EditClick = function (a) {
            alert("UserId " + a.userId + " edit");
        }
        self.DeleteClick = function (a) {
            alert("UserId " + a.userId + " delete");
        }
        self.formLoad = function () {
            self.loadData(0, 5);
        }
        self.sortGrid = function (data, obj) {

            self.itemsTemp.sort(function (a, b) {
                var x = a['' + data];
                var y = b['' + data];
                if (x < y) { return -1; }
                if (x > y) { return 1; }
                return 0;
            });
        }


        self.filtering = function () {
            var filterInput = $('.filter');
            self.itemsTemp(self.items());
            for (var count = 0; count < filterInput.length ; count++) {

                if ($(filterInput[count]).val() != null && $(filterInput[count]).val() != "") {
                    var objlist = self.itemsTemp().filter(function (el) {
                        return (
                        (el['' + $(filterInput[count]).attr('columnname')].toString().toLowerCase() == $(filterInput[count]).val().toLowerCase())
                        ||
                        (el['' + $(filterInput[count]).attr('columnname')].toString().toLowerCase().indexOf($(filterInput[count]).val().toLowerCase()) > -1)
                        )
                        ;
                    });
                    self.itemsTemp(objlist);
                }
            }
        }
        self.ResetClick = function () {
            $('.filter').val("");
            self.itemsTemp(self.items());
        }
        self.formLoad();
    };

    $(document).ready(function () {
        ko.applyBindings(new PagedGridModel());
    });
</script>
<body>
    <form id="form1" runat="server">
        <br />
        <div style="width: 90%; text-align: right; margin-left: 10px">
            <b>Page Size: </b>
            <select id="Scount" data-bind="value: pageSize, event: { change: pageSizeChange }" class="ddlWidth260 ddl">
                <option value="5">5</option>
                <option value="10">10</option>
                <option value="20">20</option>
                <option value="50">50</option>

            </select>
        </div>

        <div style="width: 90%; margin-left: 10px">
            <table id="tblHeading" border="1" style="width: 100%;">
                <thead>
                    <tr>
                        <td>

                            <a class="cursor bold " data-bind="click: $root.sortGrid.bind(this, 'userId')">UserId</a>
                            <br />
                            <%-- <div style="position:relative;">
                                <i class="fa fa-filter" style="position:absolute; top:0x; left:0px;"></i>--%>
                            <input type="text" class="width100 filter" columnname="userId" aria-hidden="true" data-bind="event: { keyup: $root.filtering.bind(this, 'userId') }" />
                            <%--</div>--%>
                        </td>



                        <td>
                            <a class="cursor bold" data-bind="click: $root.sortGrid.bind(this, 'name')">Name</a>
                            <br />
                            <i class="icon-search icon-2x">
                                <input type="text" class="width100 filter" columnname="name" data-bind="event: { keyup: $root.filtering.bind(this, 'name') }" />
                            </i>
                        </td>
                        <td>
                            <a class="cursor bold" data-bind="click: $root.sortGrid.bind(this, 'price')">Price</a>
                            <br />
                            <input type="text" class="width100 filter" columnname="price" data-bind="event: { keyup: $root.filtering.bind(this, 'price') }" />
                        </td>
                        <td>
                            <a class="cursor bold" data-bind="click: $root.sortGrid.bind(this, 'sales')">Sales</a>
                            <br />
                            <input type="text" class="width100 filter" columnname="sales" data-bind="event: { keyup: $root.filtering.bind(this, 'sales') }" />
                        </td>
                        <td>    <br />
                            <button data-bind="click: $root.ResetClick, value: userId">Reset</button>
                        </td>
                    </tr>
                </thead>
                <tbody data-bind="foreach: itemsTemp">
                    <tr>
                        <td id="userId" data-bind="text: userId"></td>
                        <td data-bind="text: name"></td>
                        <td data-bind="text: price"></td>
                        <td data-bind="text: sales"></td>
                        <td>
                            <button data-bind="click: $root.EditClick, value: userId">Edit</button>
                            <button data-bind="click: $root.DeleteClick, value: userId">Delete</button>
                        </td>

                    </tr>

                </tbody>
            </table>
            <div data-bind="foreach: itemsPaging" style="font-size: xx-large; width: 100%;">
                &nbsp;<span style="background-color: lightgrey">
                    <a href="#" style="margin: 15px;" data-bind="text: $data, click: $root.moveToPage "></a>
                </span>&nbsp;
            </div>

        </div>
    </form>
</body>
</html>

